<?php

namespace Ems\Controllers;

use Exception\Messages;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\DTO\Response\Message;
use Doctrine\ORM\EntityManager;

use Ems\Services\ProcessoService;

class ProcessoController {
    
    /** @var ProcessoService */
    protected $processoService;
    
    public function __construct(
        ProcessoService $processoService
    ) {
        $this->processoService = $processoService;
    }
    
    public function getStatusProcesso(
        Request\Row $request,
        Response    $response
    ) {
        try {
            $row = $request->getRow();
            
            $status = $this->processoService->getStatusProcesso();

            $response->addDataSet(new DataSet('getStatusProcesso', $status));
        } catch (\Exception $e) {
            $response->setError(new Error($e->getMessage(), $e->getCode(), $e->getTrace(), $e));
        }
    }
}
