CREATE OR REPLACE PROCEDURE COMPOSICAO_RECEITA_PROVRECCOC(
P_CDRECEITA IN VARCHAR2,
P_QTRECEITA IN FLOAT,
P_NRNIVEL IN NUMBER,
P_NRPRODUCAOCOC IN FLOAT
)
AS
V_NRRECPRODUCOC VARCHAR2(20);
V_NRSUBRECPRODUCOC VARCHAR2(20);
V_NRPRODPRODUCOC VARCHAR2(20);
V_QTBRUTA FLOAT;
V_VRYIELD FLOAT;
V_QTREND FLOAT;
V_CDSETOR VARCHAR2(4);

V_NRRECPRODUCOC_EXISTENTE NUMBER;
V_NRSUBRECPRODUCOC_EXISTENTE NUMBER;
V_NRPRODPRODUCOC_EXISTENTE NUMBER;
BEGIN
   -- Setor da receita
   SELECT MAX(CDSETOR)
     INTO V_CDSETOR
     FROM PRODUTO
    WHERE CDPRODUTO = P_CDRECEITA;

   -- Rendimento da receita
   SELECT MAX(QTREND)
     INTO V_QTREND
     FROM
   (SELECT NVL(QTRENDRECLOC, 0) AS QTREND
      FROM RENDLOCAL
      WHERE CDRECEITA = P_CDRECEITA
   UNION
   SELECT NVL(QTRENDRECPAD, 0) AS QTREND
     FROM RENDPADRAO
    WHERE CDRECEITA = P_CDRECEITA);
   
   IF V_QTREND > 0 AND P_QTRECEITA > 0 THEN
      --Verifica se a receita j existe
      SELECT MAX(NRRECPRODUCOC)
        INTO V_NRRECPRODUCOC_EXISTENTE
        FROM RECPRODUCOC
       WHERE NRPRODUCAOCOC = P_NRPRODUCAOCOC
         AND CDRECEITA = P_CDRECEITA; 
      
      IF V_NRRECPRODUCOC_EXISTENTE IS NULL THEN
      -- Insere a receita
         NOVO_CODIGO_SC('RECPRODUCOC', V_NRRECPRODUCOC);
      
         INSERT INTO RECPRODUCOC
         (NRPRODUCAOCOC, NRRECPRODUCOC, CDRECEITA,
          CDSETOR, QTRECPRODUCOC,
          NRNIVEL, DTULTATU)      
         VALUES
         (P_NRPRODUCAOCOC, TO_NUMBER(V_NRRECPRODUCOC), P_CDRECEITA,
          V_CDSETOR, P_QTRECEITA,
          P_NRNIVEL, SYSDATE);
          
      ELSE
         UPDATE RECPRODUCOC
            SET QTRECPRODUCOC = QTRECPRODUCOC + P_QTRECEITA
          WHERE NRRECPRODUCOC = V_NRRECPRODUCOC_EXISTENTE;
      END IF;
      
      -- Percorre cada item da receita (produtos e subreceitas
      FOR C_COMP IN
      (
      SELECT PT.CDSETOR,
             PT.CDPRODUTO,
             NVL(PT.VRPEFATOCORR, 0) AS VRPEFATOCORR,             
             ROUND(C.QTINSUMO * (P_QTRECEITA / V_QTREND), 3) AS QUANTIDADE, -- Insumos necessrios para qtde/rend receitas
             CASE WHEN PT.IDPRODCOMISS IS NULL THEN 'P' ELSE 'R' END AS TIPO
        FROM (SELECT CDPRODUTO, MAX(CDESPEPROD) AS CDESPEPROD
                FROM ESPEPROD
               WHERE (CDMANCIA IS NULL OR IDTPMANUAL IS NULL)
               GROUP BY CDPRODUTO) E
             INNER JOIN (SELECT CDPRODUTO, CDESPEPROD, MAX(CDTIPOCOMP) CDTIPOCOMP
                           FROM TCOMPPRO
                           GROUP BY CDPRODUTO, CDESPEPROD) T ON T.CDPRODUTO = E.CDPRODUTO AND
                                                                T.CDESPEPROD = E.CDESPEPROD
             INNER JOIN COMPPROD C ON C.CDPRODUTO = E.CDPRODUTO AND
                                      C.CDESPEPROD = E.CDESPEPROD AND
                                      C.CDTIPOCOMP = T.CDTIPOCOMP
             INNER JOIN PRODUTO PT ON PT.CDPRODUTO = C.CDPRODINSUMO             
       WHERE E.CDPRODUTO = P_CDRECEITA
      ) LOOP
         -- Se item da composio for produto, insere-o
         IF C_COMP.TIPO = 'P' THEN
            NOVO_CODIGO_SC('PRODPRODUCOC', V_NRPRODPRODUCOC);
            
            V_VRYIELD := ROUND(100 - C_COMP.VRPEFATOCORR, 2);
            V_QTBRUTA := ROUND(C_COMP.QUANTIDADE / (1 - C_COMP.VRPEFATOCORR/100), 3);
            
            IF V_NRRECPRODUCOC_EXISTENTE IS NULL THEN
               INSERT INTO PRODPRODUCOC
               (NRPRODUCAOCOC, NRPRODPRODUCOC,
                CDPRODUTO, CDSETOR,
                NRRECPRODUCOC, QTPRODPRODUCOC,
                QTBRUTA, VRYIELD,
                DTULTATU)
               VALUES
               (P_NRPRODUCAOCOC, TO_NUMBER(V_NRPRODPRODUCOC),
                C_COMP.CDPRODUTO, V_CDSETOR,
                TO_NUMBER(V_NRRECPRODUCOC), C_COMP.QUANTIDADE,
                V_QTBRUTA, V_VRYIELD,
                SYSDATE);
            ELSE
               --Busca produto existente associado  receita j existente
               SELECT MAX(NRPRODPRODUCOC)
                 INTO V_NRPRODPRODUCOC_EXISTENTE
                 FROM PRODPRODUCOC
                WHERE NRPRODUCAOCOC = P_NRPRODUCAOCOC
                  AND NRRECPRODUCOC = V_NRRECPRODUCOC_EXISTENTE
                  AND CDPRODUTO = C_COMP.CDPRODUTO;
                  
               UPDATE PRODPRODUCOC
                  SET QTPRODPRODUCOC = QTPRODPRODUCOC + C_COMP.QUANTIDADE,
                      QTBRUTA = QTBRUTA + V_QTBRUTA
               WHERE NRPRODPRODUCOC = V_NRPRODPRODUCOC_EXISTENTE;
            END IF;
         -- Se item da composio  subreceita, insere a subreceita e chama essa rotina para ela, recursivamente
         ELSE
            NOVO_CODIGO_SC('SUBRECPRODUCOC', V_NRSUBRECPRODUCOC);
            
            IF V_NRRECPRODUCOC_EXISTENTE IS NULL THEN
               INSERT INTO SUBRECPRODUCOC
               (NRPRODUCAOCOC, NRSUBRECPRODUCOC,
                NRRECPRODUCOC, CDRECEITA,
                CDSETOR, QTSRECPRODUCOC,
                DTULTATU)
               VALUES
               (P_NRPRODUCAOCOC, TO_NUMBER(V_NRSUBRECPRODUCOC),
                TO_NUMBER(V_NRRECPRODUCOC), C_COMP.CDPRODUTO,
                C_COMP.CDSETOR, C_COMP.QUANTIDADE,
                SYSDATE);
            ELSE
               SELECT MAX(NRSUBRECPRODUCOC)
                 INTO V_NRSUBRECPRODUCOC_EXISTENTE
                 FROM SUBRECPRODUCOC
                WHERE NRPRODUCAOCOC = P_NRPRODUCAOCOC
                  AND NRRECPRODUCOC = V_NRRECPRODUCOC_EXISTENTE
                  AND CDRECEITA = C_COMP.CDPRODUTO;
                  
               UPDATE SUBRECPRODUCOC
                  SET QTSRECPRODUCOC = QTSRECPRODUCOC + C_COMP.QUANTIDADE
                WHERE NRSUBRECPRODUCOC = V_NRSUBRECPRODUCOC_EXISTENTE;
            END IF;
            
            COMPOSICAO_RECEITA_PROVRECCOC(C_COMP.CDPRODUTO, C_COMP.QUANTIDADE, P_NRNIVEL+1, P_NRPRODUCAOCOC);
         END IF;
      END LOOP;
   END IF;
END;
/
-- VERSAO --
BEGIN ATUVEROBJ('COMPOSICAO_RECEITA_PROVRECCOC','5.85.xxx'); END;
/